import abiturklassen.graphklassen.*;
import abiturklassen.listenklassen.List;

public class Wegsuche {
  private Graph graph;
  private char naechsterKnoten;
  private boolean zielErreicht = false;

  public Wegsuche(){
    graph = new Graph();
    naechsterKnoten = 'A';
  }

  public GraphNode knotenEinfuegen() {
    GraphNode knoten = new GraphNode("" + naechsterKnoten);
    graph.addNode(knoten);
    naechsterKnoten = (char)(naechsterKnoten+1);
    return knoten;
  }

  public boolean kanteEinfuegen(String pName1, String pName2, double pGewicht) {
     GraphNode knoten1 = graph.getNode(pName1);
     GraphNode knoten2 = graph.getNode(pName2);
     boolean moeglich = (knoten1 != null) && (knoten2 != null);
     if (moeglich)
       graph.addEdge(knoten1,knoten2,pGewicht);
     return moeglich;
  }

  public List gibWeg(String pVon, String pNach) {
    GraphNode vonKnoten = graph.getNode(pVon);
    GraphNode nachKnoten = graph.getNode(pNach);
    List weg = null;
    if ((vonKnoten != null) && (nachKnoten != null)) {
      List knotenliste = new List();
      graph.resetMarks();
      vonKnoten.mark();
      knotenliste.append(vonKnoten);
      zielErreicht = false;
      weg = findeWeg(vonKnoten, nachKnoten, knotenliste);
    }
    return weg;
  }

  private List findeWeg( GraphNode pVonKnoten, GraphNode pNachKnoten, List pWeg) {
    if (pVonKnoten != pNachKnoten) {
      List nachbarKnoten = graph.getNeighbours(pVonKnoten);
      nachbarKnoten.toFirst();
      while ((nachbarKnoten.hasAccess())&& (!zielErreicht)) {
        GraphNode knoten = (GraphNode) nachbarKnoten.getObject();
        if (!knoten.isMarked()) {
          knoten.mark();
          pWeg.append(knoten);
          double kantenlaenge = graph.getEdgeWeight(pVonKnoten, knoten);
          findeWeg (knoten, pNachKnoten, pWeg);
          if (!zielErreicht) {
            knoten.unmark();
            pWeg.toLast();
            pWeg.remove();
          }
        }
        nachbarKnoten.next();
      }
    } else
        zielErreicht = true;
    if (zielErreicht)
      return pWeg;
    else
      return new List();
  }

  double gibWegLaenge(List wegliste) {
    double wegLaenge = 0;
    if (!((wegliste == null) && (!wegliste.isEmpty()))){
      wegliste.toFirst();
      GraphNode wegKnoten1 = (GraphNode) wegliste.getObject();
      wegliste.next();
      while (wegliste.hasAccess()) {
        GraphNode wegKnoten2 = (GraphNode) wegliste.getObject();
        double distanz = graph.getEdgeWeight(wegKnoten1, wegKnoten2);
        wegLaenge = wegLaenge + distanz;
        wegKnoten1 = wegKnoten2;
        wegliste.next();
      }
    }
    return wegLaenge;
  }
}